﻿using System;
using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;
using System.Collections.Generic;
using System.Diagnostics;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.IO;

namespace FeatureGuideCharp
{
    class TimezoneSettingREST
    {
        private string API_KEY = "your_api_key";
        private string API_URL = "https://sandbox.esignlive.com/api";
        private string FILE_PATH = "your_file_path";

        public void SenderTimezone()
        {
            changeSenderTimezone("18EZDL44xgsX", "GMT");
        }


        private void changeSenderTimezone(String senderId, String timezone) {
            // Prepare the client
            HttpClient httpClient = new HttpClient();
            httpClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", API_KEY);
            httpClient.DefaultRequestHeaders.Add("Accept", "application/json");

            // Add sender
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("      {");
            sb.AppendLine("         \"timezoneId\" : \"" + timezone + "\"");
            sb.AppendLine("      }");
            StringContent requestContent = new StringContent(sb.ToString(), Encoding.UTF8, "application/json");

            string url = new Uri(C.API_URL) + "/account/senders/"+senderId;
            var response = httpClient.PostAsync(url, requestContent).Result;

            if (response.StatusCode != System.Net.HttpStatusCode.OK)
            {
                throw new Exception(response.Content.ReadAsStringAsync().Result);
            }
        }

        public void PackageTimeZone()
        {
            string jsonString = "{\"roles\":[{\"id\":\"Role1\",\"signers\":[{\"email\":\"signer1@mailinator.com\",\"firstName\":\"1.firstname\",\"lastName\":\"1.lastname\",\"company\":\"OneSpan Sign\"}]},{\"id\":\"Role2\",\"signers\":[{\"email\":\"signer2@mailinator.com\",\"firstName\":\"2.firstname\",\"lastName\":\"2.lastname\",\"company\":\"OneSpan Sign\"}]}],\"documents\":[{\"approvals\":[{\"role\":\"Role1\",\"fields\":[{\"page\":0,\"top\":100,\"subtype\":\"FULLNAME\",\"height\":50,\"left\":100,\"width\":200,\"type\":\"SIGNATURE\"}]},{\"role\":\"Role2\",\"fields\":[{\"page\":0,\"top\":300,\"subtype\":\"FULLNAME\",\"height\":50,\"left\":100,\"width\":200,\"type\":\"SIGNATURE\"}]}],\"name\":\"Test Document\"}],\"name\":\"Test Time Zone\",\"type\":\"PACKAGE\",\"language\":\"en\",\"emailMessage\":\"\",\"description\":\"New Package\",\"autocomplete\":true,\"status\":\"DRAFT\",\"timezoneId\":\"JST\"}";

            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            byte[] fileByteArray = File.ReadAllBytes(FILE_PATH);
            ByteArrayContent content = new ByteArrayContent(fileByteArray);

            content.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content.Headers.ContentDisposition.Name = "\"file\"";
            content.Headers.ContentDisposition.FileName = "\"NAME_OF_YOUR_FILE.pdf\"";
            content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content, "\"file\"", "\"NAME_OF_YOUR_FILE.pdf\"");
            form.Add(jsonContent, "\"payload\"");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", API_KEY);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.PostAsync(new Uri(API_URL) + "/packages/", form).Result;

            if (response.StatusCode == System.Net.HttpStatusCode.OK)
            {
                Debug.WriteLine(response.Content.ReadAsStringAsync().Result);
            }
            else {
                throw new Exception(response.Content.ReadAsStringAsync().Result);
            }
            





        }
    }
}
